<template>
  <div>
    <div class="row">
      <div class="col-xs-12 col-md-6">
        <el-input
          v-model="search"
          placeholder="Rechercher sur le nom"
        />
      </div>
    </div>
    <div class="row">
      <el-table
        ref="groupsTable"
        :data="pagedAndFilteredGroups"
        :default-sort="{prop: 'createdAt', order: 'descending'}"
        border
        stripe
        style="width: 100%"
        @selection-change="handleSelectionChange"
      >
        <el-table-column
          prop="createdAt"
          label="Date d'ajout"
        >
          <template slot-scope="scope">
            {{ scope.row.createdAt.date | beautifulDate }}
          </template>
        </el-table-column>
        <el-table-column
          prop="name"
          label="Nom"
        />
        <el-table-column
          prop="sirets"
          label="Entreprise(s) et Établissement(s)"
        >
          <template slot-scope="scope">
            <p v-if="scope.row.sirets.length > 3">
              <el-button
                type="text"
                @click="seeMore(scope.row.sirets)"
              >
                Voir les {{ scope.row.sirets.length }} éléments
              </el-button>
            </p>
            <p
              v-for="groupSiret in scope.row.sirets"
              v-else
              :key="groupSiret.nic"
            >
              {{ groupSiret.siren }} - {{ groupSiret.nic }}
            </p>
          </template>
        </el-table-column>
        <el-table-column
          prop="edit"
          label=""
        >
          <template slot-scope="scope">
            <click-button
              :disabled="isLoading"
              @click="$router.push({'path':'/groupements/modifier/'+scope.row.id})"
            >
              <template #content>
                <edit-icon />
              </template>
            </click-button>
            <click-button
              :disabled="isLoading"
              @click="confirmDeleteGroup(scope.row)"
            >
              <template #content>
                <remove-icon />
              </template>
            </click-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div class="row">
      <el-pagination
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next"
        :total="filteredGroups.length"
        @current-change="handleCurrentChange"
      />
    </div>
    <confirmation-modal-delete
      id="confirmationModalDelete"
      text="Êtes-vous sûr de vouloir supprimer ce groupement ?"
      @okClicked="performDeleteGroup"
    />
  </div>
</template>
<script>
import {mapActions, mapGetters} from 'vuex'
import VanillaToasts from 'vanillatoasts'
import ConfirmationModalDelete from '../../../components/Modal/ConfirmationModal'
import RemoveIcon from '../../../components/Icon/RemoveIcon.vue'
import EditIcon from '../../../components/Icon/EditIcon.vue'
import ClickButton from "../../../components/Button/ClickButton";
export default {
  name: 'GroupTable',
  components: {
    ClickButton,
    ConfirmationModalDelete,
    RemoveIcon,
    EditIcon
  },
  data() {
    return {
      search: '',
      multipleSelection: [],
      currentPage: 1,
      pageSize: 10,
    }
  },
  computed: {
    ...mapGetters([
      'isLoading',
      'groups',
      'group'
    ]),
    pagedAndFilteredGroups() {
      return !this.search
        ?
        this.groups.slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)
        :
        this.groups.filter(group => group.name.toLowerCase().includes(this.search.toLowerCase())).slice(this.pageSize * this.currentPage - this.pageSize, this.pageSize * this.currentPage)

    },
    filteredGroups() {
      return this.search ? this.groups.filter(group => group.name.toLowerCase().includes(this.search.toLowerCase())) : this.groups
    },
  },
  methods: {
    ...mapActions([
      'deleteGroup',
      'setGroup'
    ]),
    seeMore(sirets) {
      let text = ''
      sirets.forEach(siret => {
        text+= siret.siren + '-' + siret.nic + ', '
      });
      text = text.substring(0, text.length-2)
      this.$alert(text, 'Entreprise(s) et Établissement(s)', {
        confirmButtonText: 'Retour'
      });
    },
    confirmDeleteGroup(group) {
      this.setGroup(group)
      $('#confirmationModalDelete').modal({keyboard:false,backdrop:'static'})
    },
    performDeleteGroup() {
      this.deleteGroup(this.group.id).then(()=>{
        VanillaToasts.create({
          title: 'Suppression groupement',
          text: 'Opération effectuée avec succès',
          type: 'success',
          timeout: 5000,
        });
      })
    },
    handleCurrentChange(val) {
      this.currentPage = val
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
  } 
}
</script>

<style scoped>
.row {
  margin-top: 2vh;
}
</style>